/* this is for variational ansatz based on a idea of J.Richter 21Jan00 */

#include "ansatz.h"
#include "hilbert.h"


/* projection operator for variational ansatz
 *  return: 1=ansatz 2=null
 *  ToDo2017: ansatz-auto_check, last check v1.4.7 2001 (for speed_test?)
 */
int ansatz_test(tbase ib1){
  int i1,sun,ip1,ip2;
  for(sun=i1=0;i1<nw;i1++){
    ip1=geti(ib1,iw[i1][0]);
    ip2=geti(ib1,iw[i1][1]);
    if(ip1==ip2)		/* |uu> or |dd> */
    if(ww.wj[i1]==1) sun++;	/* count AFM-excitations */
    
  }       
  return ((sun<=28)?1:0);	/* square-lattice-AFM mind. 6 excitations */
  /* square-lattice: sun<= 0,6,8,10,12,14,18,20,24 */
}
